# TODO: genpeimg (from mingw-w64-tools?)
#
# Conditional build:
%bcond_with	pesign	# sign EFI binary (pesign is NFY)

Summary:	Firmware update EFI binaries
Summary(pl.UTF-8):	Binaria EFI do uaktualniania firmware'u
Name:		fwupd-efi
Version:	1.7
Release:	1
License:	LGPL v2+
Group:		Base
#Source0Download: https://github.com/fwupd/fwupd-efi/releases
Source0:	https://github.com/fwupd/fwupd-efi/archive/%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	25999796ab59a4edebaa8d7d71808c56
URL:		https://github.com/fwupd/fwupd-efi
BuildRequires:	gnu-efi >= 1:3.0.18
BuildRequires:	meson >= 0.62.0
BuildRequires:	ninja >= 1.5
%{?with_pesign:BuildRequires:	pesign}
BuildRequires:	python3 >= 1:3.6
BuildRequires:	python3-pefile
BuildRequires:	python3-uswid >= 0.4.3
BuildRequires:	tar >= 1:1.22
BuildRequires:	xz
Requires:	fwupd >= 1.6.0
ExclusiveArch:	%{ix86} %{x8664} x32 %{arm} aarch64 loongarch64 riscv64
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		efi_arch	%(echo %{_target_base_arch} | sed -e 's/i386/ia32/;s/x86_64/x64/;s/aarch64/aa64/')

%define		_enable_debug_packages	0

%description
fwupd is a project to allow updating device firmware, and this package
provides the EFI binary that is used for updating using UpdateCapsule.

%description -l pl.UTF-8
fwupd to projekt pozwalający uaktualniać firmware urządzeń. Ten pakiet
dostarcza program binarny EFI służący do uaktualniania przy użyciu
UpdateCapsule.

%package devel
Summary:	Development file for fwupd-efi
Summary(pl.UTF-8):	Plik programistyczny pakietu fwupd-efi
Group:		Development/Libraries

%description devel
Development file for fwupd-efi.

Plik programistyczny pakietu fwupd-efi.

%prep
%setup -q

%ifarch x32
# -m64 is needed to build x64 EFI
%{__sed} -i -e "/^if host_cpu == 'x86_64'/,/^elif/ s/'-mno-red-zone',/& '-m64',/" efi/meson.build
%{__sed} -i -e 's/args\.cc, /&"-m64", /' efi/generate_sbat.py
%endif

%build
%meson build \
	-Defi-ldsdir=%{_libdir} \
	-Defi_sbat_distro_id="pld" \
	-Defi_sbat_distro_summary="PLD Linux" \
	-Defi_sbat_distro_pkgname="%{name}" \
	-Defi_sbat_distro_version="%{version}" \
	-Defi_sbat_distro_url="https://pld-linux.org/" \

%ninja_build -C build

%install
rm -rf $RPM_BUILD_ROOT

%ninja_install -C build

%if %{with pesign}
%pesign -s -i $RPM_BUILD_ROOT%{_libexecdir}/fwupd/efi/fwupd%{efi_arch}.efi \
	-o $RPM_BUILD_ROOT%{_libexecdir}/fwupd/efi/fwupd%{efi_arch}.efi.tmp
%pesign -s -i $RPM_BUILD_ROOT%{_libexecdir}/fwupd/efi/fwupd%{efi_arch}.efi.tmp \
	-o $RPM_BUILD_ROOT%{_libexecdir}/fwupd/efi/fwupd%{efi_arch}.efi.signed
%{__rm} $RPM_BUILD_ROOT%{_libexecdir}/fwupd/efi/fwupd%{efi_arch}.efi.tmp
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc AUTHORS COMMITMENT MAINTAINERS README.md SECURITY.md
%dir %{_libexecdir}/fwupd
%dir %{_libexecdir}/fwupd/efi
%{_libexecdir}/fwupd/efi/fwupd%{efi_arch}.efi
%if %{with pesign}
%{_libexecdir}/fwupd/efi/fwupd%{efi_arch}.efi.signed
%endif

%files devel
%defattr(644,root,root,755)
%{_pkgconfigdir}/fwupd-efi.pc
%changelog
* Thu Nov 07 2024 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/fwupd-efi.git;a=log;h=master

* Thu Nov 07 2024 Jakub Bogusz <qboosh@pld-linux.org> f8b154a
- updated to 1.7

* Sun May 19 2024 Jakub Bogusz <qboosh@pld-linux.org> eb0e850
- explicit efi-ldsdir to fix build on x86_64 and x32

* Sun May 19 2024 Jakub Bogusz <qboosh@pld-linux.org> 1d07073
- updated to 1.5

* Sat Apr 01 2023 Jakub Bogusz <qboosh@pld-linux.org> 4307609
- updated to 1.4

* Fri Jul 08 2022 Jakub Bogusz <qboosh@pld-linux.org> 6b0299f
- updated to 1.3

* Sat Feb 26 2022 Jakub Bogusz <qboosh@pld-linux.org> 9934b54
- updated to 1.2

* Sun Sep 19 2021 Jakub Bogusz <qboosh@pld-linux.org> 6bcf376
- updated to 1.1
- added ExclusiveArch list

* Sun Jul 11 2021 Jan Rękorajski <baggins@pld-linux.org> 5a14db0
- package owned directories, rel 2

* Tue Jun 15 2021 Jakub Bogusz <qboosh@pld-linux.org> b039779
- build x64 EFI binary on x32

* Tue Jun 15 2021 Jakub Bogusz <qboosh@pld-linux.org> 90a7ae1
- disable debug packages (binary is PE*, not ELF), fixed efi_arch on x86_64

* Tue Jun 15 2021 Jakub Bogusz <qboosh@pld-linux.org> 6ffb867
- initial

